from common.git_helpers import get_all_commits

def get_split_version(version):
    post = 0
    patch = 0
    minor = 0
    major = 0

    version = version.strip().split('.')

    try:
        major = int(version[0])
    except:
        major = 0

    try:
        minor = int(version[1])
    except:
        minor = 1

    try:
        patch = int(version[2])
    except:
        patch = 0

    try:
        post = int(version[3])
    except:
        post = 0

    return (major, minor, patch, post)

def get_new_version(last_version, last_hexsha):
    last_version = get_split_version(last_version)

    MAJOR = last_version[0]
    MINOR = last_version[1]
    PATCH = last_version[2]
    POST = last_version[3]

    version = ''
    hexsha = last_hexsha

    for commit in get_all_commits():
        name = commit.message.replace("\n", "")
        hexsha = commit.hexsha
        email = commit.author.email
        committed_datetime = commit.committed_datetime

        POST = POST + 1

        if (hexsha == last_hexsha):
            MAJOR = last_version[0]
            MINOR = last_version[1]
            PATCH = last_version[2]
            POST = last_version[3] + 1
        else:
            if (str(name).strip().lower().startswith("test")):
                pass

            if (str(name).strip().lower().startswith("fix")):
                POST = 0
                PATCH = PATCH + 1

            if (str(name).strip().lower().startswith("feat")):
                POST = 0
                PATCH = 0
                MINOR = MINOR + 1

            if (str(name).strip().lower().startswith("breaking change")):
                POST = 0
                PATCH = 0
                MINOR = 0
                MAJOR = MAJOR + 1
        
        version = "{0}.{1}".format(MAJOR, MINOR)

        if (PATCH != 0):
            version = "{0}.{1}".format(version, PATCH)

        if (POST != 0):
            version = "{0}.{1}".format(version, POST)

        print("{}: {}: ({}:{}) {}".format(version, hexsha, email, committed_datetime, name))
    return version
